#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <inttypes.h>
#define TAB '\t'
#define MAX_LINE_SIZE sizeof(char) * 65536
#define EOL "\r\n"
#define NLPRINT LineNumber++;printf("%c%d%c%s",TAB,LineNumber,TAB,Line)
int main(int argc, char **argv){
    uint32_t LineNumber = 0;
    char *Line = (char *)malloc(MAX_LINE_SIZE);
    memset(Line,0,MAX_LINE_SIZE);
    puts("Kevin Guanche Darias :: nl tool");
    // File not specified use  stdin
    if(argc == 1){

        while(1){
            fgets(Line,MAX_LINE_SIZE,stdin);
            if(feof(stdin)) break;
            NLPRINT;
        }
        return EXIT_SUCCESS;
    }else if(argc == 2 && (strcmp(argv[1],"--help") == 0)){ // Show help
        puts("Kevin Guanche Darias nl for Windows");
        printf("Usage: %s [File]..."EOL,argv[0]);
        puts("Writes each file to standard output, with line numbers added");
        return EXIT_SUCCESS;
    }
    FILE *FilePointer;
    int i;
    for(i = 1; i < argc;(i++)){
        FilePointer = fopen(argv[i],"r");
        if(FilePointer != NULL){
            while(!feof(FilePointer)){
                fgets(Line,MAX_LINE_SIZE,FilePointer);
                NLPRINT;
            }
        }else{ // File Error
            printf("%s: %s is not a file "EOL,argv[0],argv[i]);
        }
        fclose(FilePointer);
    }
    return EXIT_SUCCESS;
}
